#!/bin/bash
file="$1"

timeoutvar="15"

# Check if there is any arguments
if [ "$file" == "" ]; then
   echo "Usage: $0 <file to check for>" > /dev/stderr
   exit 0
fi

# look up the parent package of a file.
function checkdep {
 line=`bzcat /var/lib/rpm-get/rpm-list.db.bz2 | grep -nx "$file" | awk -F':' '{print $1}' | head -1`
 test=`bzcat /var/lib/rpm-get/rpm-list.db.bz2 | head -$line 2>/dev/null | tail -1 | grep '.rpm' >/dev/null && echo "0" || echo "-1"`

 while test $line -ne 0 2>/dev/null; do
   curline=`bzcat /var/lib/rpm-get/rpm-list.db.bz2 | head -$line | tail -1`
   case "$curline" in
      *\.rpm)
          echo "$curline"
 	 exit 1;;
   esac
   line=`expr $line - 1`
    if [ "$test" == "0" ]; then
       exit 0
    fi
 done

 find=`bzcat /var/lib/rpm-get/rpm-list.db.bz2 | grep $1 | grep -v \/`
 echo $find | cut -d' ' -f 1
 test $fine && exit 0
}

function chkinst {
package=`checkdep $file | sed 's/..[3456]86.rpm//g'`
 test $package &&
 rpm -q $package 1>/dev/null 2>&1 && 
 echo "Package is installed" && exit 0 
# || echo "package $file is not installed" && exit -1

   if echo $file | grep "GLIBC_" >/dev/null; then 
      glibcver=`echo $file | tr -d [:alpha:][:punct:] | cut -c 2-`
      instver=`rpm -q glibc 2>/dev/null | tr -d [:alpha:][:punct:] | cut -c -2`
      if [ "$instver" -ge "$glibcver" ]; then
         echo "Package is installed" 
         exit 0
        else
         echo "$file Version missmatch." 
         exit -1 
      fi
   fi

   if echo $file | grep "rpmlib" >/dev/null; then
      echo "Not checking rpmlib...." && exit 1
   fi


# See if version of dependency is correct .... seems to work for the first
# time now ...... version 1.2 .. pffft, why didnt anyone mail to remind
# me to fix this sooner ?

   tmpway=$(echo $file | awk -F' ' '{print $(2)}')
   tmpver=$(echo $file | awk -F' ' '{print $(3)}' | tr -d [:alpha:][:punct:])
   tmppkg=$(echo $file | awk -F' ' '{print $(1)}') 
   tmpinsver=$(rpm -q $tmppkg 2>/dev/null | awk -F'-' '{print $(2)}' | tr -d [:alpha:][:punct:])
   if [ "x$tmpinsver" != "x" ]; then 
      if [ "$tmpway" == ">=" ]; then
         if [ "0$tmpver" -le "0$tmpinsver" ]; then
            rpm -q $tmppkg 2>/dev/null 
            echo "Package is installed"
            exit 0 
           else
            echo "$file Version missmatch."
            exit -1
         fi
      fi

      if [ "$tmpway" == "<=" ]; then
         if [ "0$tmpver" -ge "0$tmpinsver" ]; then
            rpm -q $tmppkg 2>/dev/null
            echo "Package is installed"
            exit 0
           else
            echo "$file Version missmatch."
            exit -1
         fi
      fi
   fi

# Main if statement for checking if a lib is installed. (seems to work)

   if [ -n `echo $file | grep '/'` ]; then
      rpm -q $file 2>/dev/null &&
      echo "Package is installed" && exit 1 ||
      rpm -q $file?* 2>/dev/null &&
      echo "Package is installed" && exit 1 ||
      rpm -qf $file 2>/dev/null &&
      echo "Package is installed" && exit 1 ||
      rpm -qf /lib/$file 2>/dev/null &&
      echo "Package is installed" && exit 1 ||
      rpm -qf /lib/$file?* 2>/dev/null &&
      echo "Package is installed" && exit 1 ||
      rpm -qf /usr/lib/$file 2>/dev/null &&
      echo "Package is installed" && exit 1 ||
      rpm -qf /usr/lib/$file?* 2>/dev/null &&
      echo "Package is installed" && exit 1 ||
      rpm -qf /usr/X11R6/lib/$file 2>/dev/null && 
      echo "Package is installed" && exit 1 ||
      rpm -qf /usr/X11R6/lib/$file?* 2>/dev/null &&
      echo "Package is installed" && exit 1 ||
      checkdep $file &&
      echo "$file is NOT installed" && 
      exit 1 
   fi
}

# Getting close.
function depversion {
rpmpkg=$1
echo $rpmpkg | sed 's/..[3456]86.rpm//g' 
test -d /tmp/rpm-tmp/ || mkdir /tmp/rpm-tmp/
rpm -qRp $rpmpkg 1>/tmp/rpm-tmp/dep-dep.$$ 2>/dev/null
rver=`cat /tmp/rpm-tmp/dep-dep.$$ | grep '>=' | tr -d [:alpha:][:punct:]`
pkglver=`cat /tmp/rpm-tmp/dep-dep.$$ | grep '>=' | awk -F'>' '{print $1}'`
prelver=`rpm -q $pkglver 2>/dev/null | tr -d [:alpha:][:punct:]`
lver=`echo $prelver | tr -d [:alpha:][:punct:]`

test $lver && test $rver &&
test $lver -ge $rver &&

echo "Package is installed" && rm -f /tmp/rpm-tmp/dep-dep.$$ && exit 1 ||
echo "Package is NOT installed" && rm -f /tmp/rpm-tmp/dep-dep.$$ && exit 0
rm -f /tmp/rpm-tmp/dep-dep.$$
}


# if the file dont seem to exist in the database.
function timeout {
sleep $1
chkinst $file

test -d /tmp/rpm-tmp/ || mkdir /tmp/rpm-tmp/
cat > /tmp/rpm-tmp/dep-loop.$$ << EOF
for files in `rpm -qRp $runpkg`; do
    chkinst $files
done
chmod 755 /tmp/rpm-tmp/dep-loop.$$; /tmp/rpm-tmp/dep-loop.$$
rm -f /tmp/rpm-tmp/dep-loop.$$
EOF
exit 0
}

# Script for versions ... 
#cat > /tmp/rpm-tmp/dep-ver.$$ << EOF
#
#chmod 755 /tmp/rpm-tmp/dep-ver.$$; /tmp/rpm-tmp/dep-ver.$$
#rm -f /tmp/rpm-tmp/dep-ver.$$
#EOF



# Start this whole script ...
timeout $timeoutvar &
sleep `expr $timeoutvar + 1`
